---
title: Add a Custom Survey Creator Theme
product: Survey Creator
description: Learn how to create a custom UI theme using CSS variables and apply it to Survey Creator. This JavaScript form builder demo explains how to design a theme from scratch or by overriding some of the CSS variables of the built-in Light theme.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/add-custom-theme/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Add a Custom Survey Creator Theme (Angular)

Survey Creator UI themes allow users to quickly adjust the appearance of the tool. Four predefined UI themes are included out of the box: Light, Dark, Contrast, and a classic Survey Creator 2020 theme. This example demonstrates how to create and apply a custom UI theme to Survey Creator.

Follow the steps below to add a custom Survey Creator theme:

1. Define a theme object.\
This object must include a unique theme identifier and a nested object with CSS variables. A theme is defined by many CSS variables, but you may specify only the variables that you want to override in the Light theme.

2. Specify a localized user-friendly theme name.\
This name will be displayed in the drop-down theme list. Use [Survey Creator's localization capabilities](https://surveyjs.io/survey-creator/documentation/survey-localization-translate-surveys-to-different-languages#override-individual-translations) for this.

3. Register the custom theme.\
Pass the theme object to the `registerCustomTheme(theme)` method. This is a static method that you can import form the `survey-creator-core` module or access via the `SurveyCreatorCore` object.

4. Apply the custom theme to Survey Creator.\
Pass the theme object to `SurveyCreatorModel`'s [`applyCreatorTheme(theme)`](/survey-creator/documentation/api-reference/survey-creator#applyCreatorTheme) method.

Refer to the Code tab for a code example.

<!-- For more information on working with CSS variables, refer to the <a href="https://www.figma.com/design/i6Lpc7zkjHtso2oXZV97fo/Design-Kit?node-id=25438-62239&t=Efr3Z8ZOPsVDIzPP-0" target="_blank">SurveyJS Figma</a> project. -->

## Files

### `src/app/components/creator.component.css`

```css
/* You can define custom CSS rules here */
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/theme_json.js`

```js
export const customThemeVariables = {
  "--sjs-layer-1-background-500": "#FFFFFFFF",
  "--sjs-layer-1-background-400": "#E6EBF9FF",
  "--sjs-layer-1-foreground-100": "#122243FF",
  "--sjs-layer-1-foreground-50": "#0E205580",
  "--sjs-layer-3-background-500": "#EAF0FBFF",
  "--sjs-layer-3-foreground-100": "#273859FF",
  "--sjs-layer-3-foreground-50": "#26335880",
  "--sjs-layer-2-background-500": "#F2F6FDFF",
  "--sjs-layer-2-background-400": "#DAE2F7FF",
  "--sjs-special-haze": "#0930A040",
  "--sjs-border-25": "#C2CEE6FF",
  "--sjs-border-10": "#CDD7EAFF",
  "--sjs-primary-background-500": "#0930A0FF",
  "--sjs-primary-background-10": "#0435C41A",
  "--sjs-primary-background-400": "#042480FF",
  "--sjs-primary-foreground-100": "#FFFFFFFF",
  "--sjs-primary-foreground-25": "#FFFFFF40",
  "--sjs-secondary-background-500": "#D6378AFF",
  "--sjs-secondary-background-25": "#D6378A40",
  "--sjs-secondary-background-10": "#D6378A1A",
  "--sjs-secondary-foreground-100": "#FFFFFFFF",
  "--sjs-secondary-forecolor-25": "#FFFFFF40",
  "--sjs-semantic-red-background-500": "#D6378AFF",
  "--sjs-semantic-red-background-10": "#D6378A1A",
  "--sjs-semantic-red-foreground-100": "#FFFFFFFF",
  "--sjs-semantic-green-background-500": "#19B394FF",
  "--sjs-semantic-green-background-10": "#19B3941A",
  "--sjs-semantic-green-foreground-100": "#FFFFFFFF",
  "--sjs-semantic-blue-background-500": "#437FD9FF",
  "--sjs-semantic-blue-background-10": "#437FD91A",
  "--sjs-semantic-blue-foreground-100": "#FFFFFFFF",
  "--sjs-semantic-yellow-background-500": "#FF9814FF",
  "--sjs-semantic-yellow-background-10": "#FF98141A",
  "--sjs-semantic-yellow-foreground-100": "#FFFFFFFF",
  "--sjs-semantic-white-background-500": "#FFFFFFFF",
  "--sjs-code-gray-700": "#B6B6B6FF",
  "--sjs-code-blue-500": "#326FCAFF",
  "--sjs-code-gray-300": "#505050FF",
  "--sjs-code-green-500": "#08997CFF",
  "--sjs-code-red-500": "#F41B50FF",
  "--sjs-code-purple-500": "#C22FA2FF",
  "--sjs-code-yellow-500": "#F58D06FF",
  "--sjs-code-gray-500": "#8A8A8AFF",
  "--sjs-special-background": "#EAF0FBFF",
  "--sjs-layer-1-foreground-75": "#0930A0FF",
  "--sjs-layer-3-background-400": "#D3DDF5FF",
  "--sjs-special-glow": "#27385933",
  "--sjs-special-shadow": "#27385940",
  "--sjs-layer-3-foreground-75": "#0930A0FF",
  "--sjs-layer-2-foreground-100": "#273859FF",
  "--sjs-layer-2-foreground-75": "#0930A0FF",
  "--sjs-layer-2-foreground-50": "#26335880",
  "--sjs-border-25-overlay": "#00000026",
  "--sjs-secondary-background-400": "#C62076FF"
}
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { customThemeVariables } from "./theme_json";
import { getLocaleStrings } from "survey-creator-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

// Step 1: Define a theme object
const customTheme = {
    themeName: "customTheme",
    cssVariables: { ...customThemeVariables }
};
const enLocale = getLocaleStrings("en");

function addCustomTheme(theme, userFriendlyThemeName) {
    // Step 2: Specify a localized user-friendly theme name
    enLocale.creatortheme.names[theme.themeName] = userFriendlyThemeName;
    // Step 3: Register the custom theme
    registerCreatorTheme(theme);
}

addCustomTheme(customTheme, "Custom Theme");

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"]
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel({ showTranslationTab: true });
        // Step 4: Apply the custom theme to Survey Creator
        creator.applyCreatorTheme(customTheme);
        
        creator.showSidebar = false;
        setTimeout(() => {
            creator.openCreatorThemeSettings();
        }, 400);
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/add-custom-theme/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/add-custom-theme/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/add-custom-theme/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/add-custom-theme/vanillajs.md)


---
title: Add a Custom Survey Creator Theme
product: Survey Creator
description: Learn how to create a custom UI theme using CSS variables and apply it to Survey Creator. This JavaScript form builder demo explains how to design a theme from scratch or by overriding some of the CSS variables of the built-in Light theme.
framework: React
source: https://surveyjs.io/survey-creator/examples/add-custom-theme/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Add a Custom Survey Creator Theme (React)

Survey Creator UI themes allow users to quickly adjust the appearance of the tool. Four predefined UI themes are included out of the box: Light, Dark, Contrast, and a classic Survey Creator 2020 theme. This example demonstrates how to create and apply a custom UI theme to Survey Creator.

Follow the steps below to add a custom Survey Creator theme:

1. Define a theme object.\
This object must include a unique theme identifier and a nested object with CSS variables. A theme is defined by many CSS variables, but you may specify only the variables that you want to override in the Light theme.

2. Specify a localized user-friendly theme name.\
This name will be displayed in the drop-down theme list. Use [Survey Creator's localization capabilities](https://surveyjs.io/survey-creator/documentation/survey-localization-translate-surveys-to-different-languages#override-individual-translations) for this.

3. Register the custom theme.\
Pass the theme object to the `registerCustomTheme(theme)` method. This is a static method that you can import form the `survey-creator-core` module or access via the `SurveyCreatorCore` object.

4. Apply the custom theme to Survey Creator.\
Pass the theme object to `SurveyCreatorModel`'s [`applyCreatorTheme(theme)`](/survey-creator/documentation/api-reference/survey-creator#applyCreatorTheme) method.

Refer to the Code tab for a code example.

<!-- For more information on working with CSS variables, refer to the <a href="https://www.figma.com/design/i6Lpc7zkjHtso2oXZV97fo/Design-Kit?node-id=25438-62239&t=Efr3Z8ZOPsVDIzPP-0" target="_blank">SurveyJS Figma</a> project. -->

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/theme_json.js`

```js
export const customThemeVariables = {
  "--sjs-layer-1-background-500": "#FFFFFFFF",
  "--sjs-layer-1-background-400": "#E6EBF9FF",
  "--sjs-layer-1-foreground-100": "#122243FF",
  "--sjs-layer-1-foreground-50": "#0E205580",
  "--sjs-layer-3-background-500": "#EAF0FBFF",
  "--sjs-layer-3-foreground-100": "#273859FF",
  "--sjs-layer-3-foreground-50": "#26335880",
  "--sjs-layer-2-background-500": "#F2F6FDFF",
  "--sjs-layer-2-background-400": "#DAE2F7FF",
  "--sjs-special-haze": "#0930A040",
  "--sjs-border-25": "#C2CEE6FF",
  "--sjs-border-10": "#CDD7EAFF",
  "--sjs-primary-background-500": "#0930A0FF",
  "--sjs-primary-background-10": "#0435C41A",
  "--sjs-primary-background-400": "#042480FF",
  "--sjs-primary-foreground-100": "#FFFFFFFF",
  "--sjs-primary-foreground-25": "#FFFFFF40",
  "--sjs-secondary-background-500": "#D6378AFF",
  "--sjs-secondary-background-25": "#D6378A40",
  "--sjs-secondary-background-10": "#D6378A1A",
  "--sjs-secondary-foreground-100": "#FFFFFFFF",
  "--sjs-secondary-forecolor-25": "#FFFFFF40",
  "--sjs-semantic-red-background-500": "#D6378AFF",
  "--sjs-semantic-red-background-10": "#D6378A1A",
  "--sjs-semantic-red-foreground-100": "#FFFFFFFF",
  "--sjs-semantic-green-background-500": "#19B394FF",
  "--sjs-semantic-green-background-10": "#19B3941A",
  "--sjs-semantic-green-foreground-100": "#FFFFFFFF",
  "--sjs-semantic-blue-background-500": "#437FD9FF",
  "--sjs-semantic-blue-background-10": "#437FD91A",
  "--sjs-semantic-blue-foreground-100": "#FFFFFFFF",
  "--sjs-semantic-yellow-background-500": "#FF9814FF",
  "--sjs-semantic-yellow-background-10": "#FF98141A",
  "--sjs-semantic-yellow-foreground-100": "#FFFFFFFF",
  "--sjs-semantic-white-background-500": "#FFFFFFFF",
  "--sjs-code-gray-700": "#B6B6B6FF",
  "--sjs-code-blue-500": "#326FCAFF",
  "--sjs-code-gray-300": "#505050FF",
  "--sjs-code-green-500": "#08997CFF",
  "--sjs-code-red-500": "#F41B50FF",
  "--sjs-code-purple-500": "#C22FA2FF",
  "--sjs-code-yellow-500": "#F58D06FF",
  "--sjs-code-gray-500": "#8A8A8AFF",
  "--sjs-special-background": "#EAF0FBFF",
  "--sjs-layer-1-foreground-75": "#0930A0FF",
  "--sjs-layer-3-background-400": "#D3DDF5FF",
  "--sjs-special-glow": "#27385933",
  "--sjs-special-shadow": "#27385940",
  "--sjs-layer-3-foreground-75": "#0930A0FF",
  "--sjs-layer-2-foreground-100": "#273859FF",
  "--sjs-layer-2-foreground-75": "#0930A0FF",
  "--sjs-layer-2-foreground-50": "#26335880",
  "--sjs-border-25-overlay": "#00000026",
  "--sjs-secondary-background-400": "#C62076FF"
}
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import { customThemeVariables } from "./theme_json";
import { getLocaleStrings } from "survey-creator-core";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

// Step 1: Define a theme object
const customTheme = {
    themeName: "customTheme",
    cssVariables: { ...customThemeVariables }
};
const enLocale = getLocaleStrings("en");

function addCustomTheme(theme, userFriendlyThemeName) {
    // Step 2: Specify a localized user-friendly theme name
    enLocale.creatortheme.names[theme.themeName] = userFriendlyThemeName;
    // Step 3: Register the custom theme
    registerCreatorTheme(theme);
}

addCustomTheme(customTheme, "Custom Theme");

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator({ showTranslationTab: true });
    // Step 4: Apply the custom theme to Survey Creator
    creator.applyCreatorTheme(customTheme);
    
    creator.showSidebar = false;
    setTimeout(() => {
        creator.openCreatorThemeSettings();
    }, 400);
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/add-custom-theme/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/add-custom-theme/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/add-custom-theme/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/add-custom-theme/vanillajs.md)
